-- Papyrus growig

minetest.register_abm({
    nodenames = { "default:papyrus" },
    interval = 7200,
    chance = 0.4,

    action = function(pos, node, active_object_count, active_object_count_wider)
        -- Individual chance for different nodes
        if(math.random(1, 1000) > 25) then
            return
        end
        
        if(minetest.env:get_node_light(pos, nil) < 6) then
            return
        end
        
        local under = {
            x = pos.x,
            y = pos.y - 1,
            z = pos.z
        }
        -- Grow sides if connected to land from bottom
        if(minetest.env:get_node(under).name == "default:grass")
        or (minetest.env:get_node(under).name == "default:dirt") then
            for i = -1, 1 do
            for j = -1, 1 do
                if(math.abs(i) + math.abs(j) == 1) then
                    if(math.random(1, 30) == 1) then
                        local new_pos = {
                            x = pos.x + i,
                            y = pos.y,
                            z = pos.z + j
                        }
                        if(minetest.env:get_node(new_pos).name == "air") then
                            minetest.env:add_node(new_pos, {name = "default:papyrus"})
                            print('[nature] A papyrus has grown at (' .. new_pos.x .. ',' .. new_pos.y .. ',' .. new_pos.z .. ')')
                        end
                    end
                end
            end
            end
        end
        -- Grow up
        local above = {
            x = pos.x,
            y = pos.y + 1,
            z = pos.z
        }
        if(minetest.env:get_node(above).name == "air") then
            minetest.env:add_node(above, {name = "default:papyrus"})
            print('[nature] A papyrus has grown at (' .. above.x .. ',' .. above.y .. ',' .. above.z .. ')')
        end
    end
})
